// CardDlg.cpp : implementation file
//
 
#include "stdafx.h"
#include "d3dtypes.h"					// Include for RGBA_MAKE macro
#include <ISTBTDDExt.h>
#include "tulsa sample app.h"
#include "mainfrm.h"
#include "CardDlg.h"
#include "config.h"
#include "InitCardDlg.h"
#include "GraphicsOptionsDlg.h"
#include "AnalogVideoEncoderTestDlg.h"
#include "MPEGDecControlDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphicsContent
/////////////////////////////////////////////////////////////////////////////
CGraphicsContent::CGraphicsContent()
{
	m_Source = SRC_GENERATE;
	m_AlphaSource = ALPHA_SRC_GENERATE;
	m_Filename[0] = NULL;
	m_StartingAlpha = 0xff;
	m_AlphaEffect = ALPHA_EFFECT_NONE;	
}

CGraphicsContent::CGraphicsContent(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\GraphicsContent");

	CWinApp* pApp = AfxGetApp();

	m_Source = (GRAPHICS_SOURCE)pApp->GetProfileInt(szKeyName, "Source", SRC_GENERATE);
	m_AlphaSource = (ALPHA_SOURCE)pApp->GetProfileInt(szKeyName, "AlphaSource", ALPHA_SRC_GENERATE);
	strcpy(m_Filename, pApp->GetProfileString(szKeyName, "BmpFilename", ""));
	m_StartingAlpha = pApp->GetProfileInt(szKeyName, "StartingAlpha", 0);
	m_AlphaEffect = (ALPHA_EFFECT)pApp->GetProfileInt(szKeyName, "AlphaEffect", ALPHA_EFFECT_NONE);
}

CGraphicsContent::CGraphicsContent(GRAPHICS_SOURCE Source, ALPHA_SOURCE AlphaSource, char* pFilename,
	int StartingAlpha, ALPHA_EFFECT AlphaEffect)
{
	m_Source = Source;
	m_AlphaSource = AlphaSource;
	strcpy(m_Filename, pFilename);
	m_StartingAlpha = StartingAlpha;
	m_AlphaEffect = AlphaEffect;	
};

CGraphicsContent::SaveToRegistry(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\GraphicsContent");

	CWinApp* pApp = AfxGetApp();

	pApp->WriteProfileInt(szKeyName, "Source", (int)m_Source);
	pApp->WriteProfileInt(szKeyName, "AlphaSource", (int)m_AlphaSource);
	pApp->WriteProfileString(szKeyName, "BmpFilename", m_Filename);
	pApp->WriteProfileInt(szKeyName, "StartingAlpha", (int)m_StartingAlpha);
	pApp->WriteProfileInt(szKeyName, "AlphaEffect", (int)m_AlphaEffect);
}



/////////////////////////////////////////////////////////////////////////////
// CGraphicsContent
/////////////////////////////////////////////////////////////////////////////
COverlayState::COverlayState()
{
	m_bShow = FALSE;
	m_Size = CSize(0, 0);
	m_Position = CPoint(0, 0);
	m_bBlend = FALSE;
	m_bInvBlend = FALSE;
	m_bFilter = FALSE;
	m_bCkEnable = FALSE;
	m_CkColor = 0;
	m_bWriteAlpha = FALSE;
};

COverlayState::COverlayState(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\OverlayState");

	CWinApp* pApp = AfxGetApp();

	m_bShow = pApp->GetProfileInt(szKeyName, "Show", FALSE);
	m_Size.cx = pApp->GetProfileInt(szKeyName, "Width", 720);
	m_Size.cy = pApp->GetProfileInt(szKeyName, "Height", 480);
	m_Position.x = pApp->GetProfileInt(szKeyName, "left", 0);
	m_Position.y = pApp->GetProfileInt(szKeyName, "top", 0);
	m_bBlend = pApp->GetProfileInt(szKeyName, "UseBlending", FALSE);
	m_bInvBlend = pApp->GetProfileInt(szKeyName, "InvertBlending", FALSE);
	m_bFilter = pApp->GetProfileInt(szKeyName, "UseFilter", FALSE);
	m_bCkEnable = pApp->GetProfileInt(szKeyName, "UseColorKey", FALSE);
	m_CkColor = pApp->GetProfileInt(szKeyName, "ColorKey", 0);
	m_bWriteAlpha = pApp->GetProfileInt(szKeyName, "WriteToAlphaChan", FALSE);

	m_Content = CGraphicsContent(szKeyName);	
}

COverlayState::COverlayState(BOOL bShow, CSize Size, CPoint Position, BOOL bBlend, BOOL bInvBlend, BOOL bFilter, BOOL bCkEnable, DWORD CkColor,  BOOL bWriteAlpha, CGraphicsContent Content)
{
	m_bShow = bShow;
	m_Size = Size;
	m_Position = Position;
	m_bBlend = bBlend;
	m_bInvBlend = bInvBlend;
	m_bFilter = bFilter;
	m_bCkEnable = bCkEnable;
	m_CkColor = CkColor;
	m_bWriteAlpha = bWriteAlpha;
	m_Content = Content;
};

COverlayState::SaveToRegistry(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\OverlayState");

	CWinApp* pApp = AfxGetApp();

	pApp->WriteProfileInt(szKeyName, "Show", (int)m_bShow);
	pApp->WriteProfileInt(szKeyName, "Width", (int)m_Size.cx);
	pApp->WriteProfileInt(szKeyName, "Height", (int)m_Size.cy);
	pApp->WriteProfileInt(szKeyName, "left", (int)m_Position.x);
	pApp->WriteProfileInt(szKeyName, "top", (int)m_Position.y);
	pApp->WriteProfileInt(szKeyName, "UseBlending", (int)m_bBlend);
	pApp->WriteProfileInt(szKeyName, "InvertBlending", (int)m_bInvBlend);
	pApp->WriteProfileInt(szKeyName, "UseFilter", (int)m_bFilter);
	pApp->WriteProfileInt(szKeyName, "UseColorKey", (int)m_bCkEnable);
	pApp->WriteProfileInt(szKeyName, "ColorKey", (int)m_CkColor);
	pApp->WriteProfileInt(szKeyName, "WriteToAlphaChan", (int)m_bWriteAlpha);
	m_Content.SaveToRegistry(szKeyName);	
}

/////////////////////////////////////////////////////////////////////////////
// CGraphicsContent
/////////////////////////////////////////////////////////////////////////////
CVideoOverlayState::CVideoOverlayState()
{
	m_SrcCropSize = CSize(0, 0);
	m_SrcCropPosition = CPoint(0, 0);
}

CVideoOverlayState::CVideoOverlayState(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\VideoOverlayState");

	*(COverlayState*)this = COverlayState(szKeyName);

	CWinApp* pApp = AfxGetApp();

	m_SrcCropSize.cx = pApp->GetProfileInt(szKeyName, "CropWidth", 720);
	m_SrcCropSize.cy = pApp->GetProfileInt(szKeyName, "CropHeight", 480);
	m_SrcCropPosition.x = pApp->GetProfileInt(szKeyName, "CropLeft", 0);
	m_SrcCropPosition.y = pApp->GetProfileInt(szKeyName, "CropTop", 0);

}

CVideoOverlayState::CVideoOverlayState(BOOL bShow, CSize Size, CPoint Position, BOOL bBlend, BOOL bInvBlend, BOOL bFilter, BOOL bCkEnable, DWORD CkColor,  BOOL bWriteAlpha, CGraphicsContent Content,
	CSize SrcCropSize, CPoint SrcCropPosition):
	COverlayState(bShow, Size, Position, bBlend, bInvBlend, bFilter, bCkEnable, CkColor,  bWriteAlpha, Content)
{
	m_SrcCropSize = SrcCropSize;
	m_SrcCropPosition = SrcCropPosition;
};

CVideoOverlayState::SaveToRegistry(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\VideoOverlayState");

	CWinApp* pApp = AfxGetApp();

	pApp->WriteProfileInt(szKeyName, "CropWidth", (int)m_SrcCropSize.cx);
	pApp->WriteProfileInt(szKeyName, "CropHeight", (int)m_SrcCropSize.cy);
	pApp->WriteProfileInt(szKeyName, "CropLeft", (int)m_SrcCropPosition.x);
	pApp->WriteProfileInt(szKeyName, "CropTop", (int)m_SrcCropPosition.y);

	COverlayState::SaveToRegistry(szKeyName);	
}



/////////////////////////////////////////////////////////////////////////////
// CGraphicsContent
/////////////////////////////////////////////////////////////////////////////
CScrollOverlayState::CScrollOverlayState()
{
	m_PixelsPerStep = 1;
	m_VerticalsPerStep = 1;
};

CScrollOverlayState::CScrollOverlayState(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\ScrollOverlayState");

	*(COverlayState*)this = COverlayState(szKeyName);

	CWinApp* pApp = AfxGetApp();

	m_PixelsPerStep = pApp->GetProfileInt(szKeyName, "PixelsPerStep", 1);
	m_VerticalsPerStep = pApp->GetProfileInt(szKeyName, "VerticalsPerStep", 1);
}

CScrollOverlayState::CScrollOverlayState(BOOL bShow, CSize Size, CPoint Position, BOOL bBlend, BOOL bInvBlend, BOOL bFilter, BOOL bCkEnable, DWORD CkColor,  BOOL bWriteAlpha, CGraphicsContent Content, int PixelsPerStep, int VerticalsPerStep):
		COverlayState(bShow, Size, Position, bBlend, bInvBlend, bFilter, bCkEnable, CkColor, bWriteAlpha, Content)
{
	m_PixelsPerStep = PixelsPerStep;
	m_VerticalsPerStep = VerticalsPerStep;
};

CScrollOverlayState::SaveToRegistry(char* pszBaseKeyName)
{
	char szKeyName[150];
	strcpy(szKeyName, pszBaseKeyName);
	strcat(szKeyName, "\\ScrollOverlayState");

	CWinApp* pApp = AfxGetApp();

	pApp->WriteProfileInt(szKeyName, "PixelsPerStep", (int)m_PixelsPerStep);
	pApp->WriteProfileInt(szKeyName, "VerticalsPerStep", (int)m_VerticalsPerStep);

	COverlayState::SaveToRegistry(szKeyName);	
}



/////////////////////////////////////////////////////////////////////////////
// Add card ID to the specified registry key
/////////////////////////////////////////////////////////////////////////////
char* CCardDlg::PrependCardID(char* buffer, char* string)
{
	sprintf(buffer, "Card%d%s", m_CardNumber, string);
	return(buffer);
}

void CCardDlg::GetCntlRect(int ID, CRect &rect)
{
	CRect rectDlg;
	CRect rectTemp;
	CRect rectCntl;

	GetWindowRect(&rectDlg);

	CWnd *pWnd = (CWnd*)GetDlgItem(ID);
	pWnd->GetWindowRect(&rectCntl);
	
	rectCntl -= rectDlg.TopLeft();

	pWnd->GetClientRect(&rectTemp);
	rect = rectCntl;
}

